package organizer;

import nextapp.echo2.app.Component;
import nextapp.echo2.app.ContentPane;
import nextapp.echo2.app.Extent;
import nextapp.echo2.app.SplitPane;
import nextapp.echo2.app.event.ActionEvent;
import nextapp.echo2.app.event.ActionListener;
import nextapp.echo2.extras.app.MenuBarPane;
import nextapp.echo2.extras.app.menu.DefaultMenuModel;
import nextapp.echo2.extras.app.menu.DefaultOptionModel;
import nextapp.echo2.extras.app.menu.MenuModel;

import organizer.components.AddWindow;
import organizer.components.TablePane;
import organizer.messages.Messages;

/**
 * Trieda MainScreen ako u nzov napoved predstavuje hlavn obrazovku aplikcie.
 * Trieda je dcrskou triedou ContentPane, o znamen, e predstavuje kontajner,
 * do ktorho sa bude priamo alebo nepriamo pridva obsah naej aplikcie.
 */
public class MainScreen extends ContentPane 
{
	public MainScreen()
	{
		// Vytvorme splitPane
		SplitPane sp = new SplitPane(SplitPane.ORIENTATION_VERTICAL,new Extent(20));
		// Vytvorme menu
		MenuBarPane menu = new MenuBarPane();
		menu.setModel(createMenuModel());
		menu.addActionListener(menuListener);
		menu.setStyleName("Menu");	
		// Pridme prvky na obrazovku	    
		sp.add(menu);
		add(sp);
	}
	
	/**
	 * Metda vytvor model v menu. Vytvori model znamen vytvori tuktru objektov, ktor bud
	 * predstavova poloky v menu.
	 * 
	 * @return Objekt MenuModel sliaci na vytvranie menu. 
	 */
	public MenuModel createMenuModel() 
	{
		DefaultMenuModel model = new DefaultMenuModel();
		// Vytvorme hlavn poloku v menu.
	    DefaultMenuModel subMenu1 = new DefaultMenuModel("1", Messages.getMessage("Menu.Create"));
	    DefaultMenuModel subMenu2 = new DefaultMenuModel("2", Messages.getMessage("Menu.Show"));
	    // Pridme do hlavnch poloiek podpoloky. 
	    subMenu1.addItem(new DefaultOptionModel("11", Messages.getMessage("Menu.Create.NewEvent"), null));
	    subMenu2.addItem(new DefaultOptionModel("21", Messages.getMessage("Menu.Show.TaskTable"), null));
	    model.addItem(subMenu1);
	    model.addItem(subMenu2);
	   
	    return model;
	}
	
    // Listener starajci sa o poloky v menu. Kadej poloke je priraden vlastn action command. Poda ation commandu
	// urme, ktor polok bola aktivovan.
	private ActionListener menuListener = new ActionListener() 
	{
		public void actionPerformed(ActionEvent ae) 
		{
			if(ae.getActionCommand().equals("11"))
			{
				AppInstance.getActive().getDefaultWindow().getContent().add(new AddWindow());
			}  else if(ae.getActionCommand().equals("21")) {
				Component cp = AppInstance.getActive().getDefaultWindow().getContent().getComponent(0);
				if(cp.getComponentCount() == 2)
					cp.remove(1);
				cp.add(new TablePane());
			}
		}
	};
}
